OpenJPH: ojph::local::param_nlt Struct Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::local::param_nlt Struct Reference

`#include <ojph_params_local.h>`

## Public Types
using | special_comp_num = ojph::param_nlt::special_comp_num
using | nonlinearity = ojph::param_nlt::nonlinearity

## Public Member Functions
| param_nlt ()
| ~param_nlt ()
void | restart ()
void | check_validity (param_siz &siz)
void | set_nonlinear_transform (ui32 comp_num, ui8 nl_type)
bool | get_nonlinear_transform (ui32 comp_num, ui8 &bit_depth, bool &is_signed, ui8 &nl_type) const
bool | write (outfile_base *file) const
void | read (infile_base *file)

## Private Member Functions
void | init ()
void | destroy ()
const param_nlt * | get_nlt_object (ui32 comp_num) const
param_nlt * | get_nlt_object (ui32 comp_num)
param_nlt * | add_object (ui32 comp_num)
bool | is_any_enabled () const
void | trim_non_existing_components (ui32 num_comps)

## Private Attributes
ui16 | Lnlt
ui16 | Cnlt
ui8 | BDnlt
ui8 | Tnlt
bool | enabled
param_nlt * | next
param_nlt * | avail

## Detailed Description

Definition at line 801 of file ojph_params_local.h.

## Member Typedef Documentation

## ◆ nonlinearity

using ojph::local::param_nlt::nonlinearity = ojph::param_nlt::nonlinearity

Definition at line 804 of file ojph_params_local.h.

## ◆ special_comp_num

using ojph::local::param_nlt::special_comp_num = ojph::param_nlt::special_comp_num

Definition at line 803 of file ojph_params_local.h.

## Constructor & Destructor Documentation

## ◆ param_nlt()

ojph::local::param_nlt::param_nlt | ( |  | ) |
| inline

Definition at line 806 of file ojph_params_local.h.

References avail, and init().

Referenced by add_object(), check_validity(), get_nlt_object(), get_nlt_object(), get_nonlinear_transform(), is_any_enabled(), read(), restart(), set_nonlinear_transform(), trim_non_existing_components(), and write().

## ◆ ~param_nlt()

ojph::local::param_nlt::~param_nlt | ( |  | ) |
| inline

Definition at line 807 of file ojph_params_local.h.

References destroy().

## Member Function Documentation

## ◆ add_object()

param_nlt * ojph::local::param_nlt::add_object | ( | ui32 | comp_num | ) |
| private

Definition at line 2040 of file ojph_params.cpp.

References avail, Cnlt, init(), next, and param_nlt().

Referenced by check_validity(), read(), and set_nonlinear_transform().

## ◆ check_validity()

void ojph::local::param_nlt::check_validity | ( | param_siz & | siz | ) |

Definition at line 1849 of file ojph_params.cpp.

References add_object(), BDnlt, enabled, ojph::local::param_siz::get_bit_depth(), get_nlt_object(), ojph::local::param_siz::get_num_components(), is_any_enabled(), ojph::local::param_siz::is_signed(), param_nlt(), ojph::local::param_siz::RSIZ_EXT_FLAG, ojph::local::param_siz::RSIZ_NLT_FLAG, ojph::local::param_siz::set_Rsiz_flag(), Tnlt, and trim_non_existing_components().

## ◆ destroy()

void ojph::local::param_nlt::destroy | ( |  | ) |
| inlineprivate

Definition at line 838 of file ojph_params_local.h.

References avail, and next.

Referenced by ~param_nlt().

## ◆ get_nlt_object() [1/2]

param_nlt * ojph::local::param_nlt::get_nlt_object | ( | ui32 | comp_num | ) |
| private

Definition at line 2022 of file ojph_params.cpp.

References get_nlt_object(), and param_nlt().

## ◆ get_nlt_object() [2/2]

const param_nlt * ojph::local::param_nlt::get_nlt_object | ( | ui32 | comp_num | ) | const
| private

Definition at line 2031 of file ojph_params.cpp.

References Cnlt, next, and param_nlt().

Referenced by check_validity(), get_nlt_object(), get_nonlinear_transform(), read(), and set_nonlinear_transform().

## ◆ get_nonlinear_transform()

bool ojph::local::param_nlt::get_nonlinear_transform | ( | ui32 | comp_num,
|  | ui8 & | bit_depth,
|  | bool & | is_signed,
|  | ui8 & | nl_type ) const

Definition at line 1954 of file ojph_params.cpp.

References BDnlt, Cnlt, enabled, get_nlt_object(), param_nlt(), and Tnlt.

Referenced by ojph::local::tile::finalize_alloc().

## ◆ init()

void ojph::local::param_nlt::init | ( |  | ) |
| inlineprivate

Definition at line 828 of file ojph_params_local.h.

References BDnlt, Cnlt, enabled, Lnlt, next, and Tnlt.

Referenced by add_object(), param_nlt(), and restart().

## ◆ is_any_enabled()

bool ojph::local::param_nlt::is_any_enabled | ( |  | ) | const
| private

Definition at line 2063 of file ojph_params.cpp.

References enabled, next, and param_nlt().

Referenced by check_validity(), and write().

## ◆ read()

void ojph::local::param_nlt::read | ( | infile_base * | file | ) |

Definition at line 2000 of file ojph_params.cpp.

References add_object(), BDnlt, Cnlt, enabled, get_nlt_object(), OJPH_ERROR, param_nlt(), ojph::infile_base::read(), ojph::local::swap_byte(), and Tnlt.

## ◆ restart()

void ojph::local::param_nlt::restart | ( |  | ) |
| inline

Definition at line 810 of file ojph_params_local.h.

References avail, init(), next, and param_nlt().

## ◆ set_nonlinear_transform()

void ojph::local::param_nlt::set_nonlinear_transform | ( | ui32 | comp_num,
|  | ui8 | nl_type )

Definition at line 1938 of file ojph_params.cpp.

References add_object(), enabled, get_nlt_object(), OJPH_ERROR, ojph::param_nlt::OJPH_NLT_BINARY_COMPLEMENT_NLT, ojph::param_nlt::OJPH_NLT_NO_NLT, param_nlt(), and Tnlt.

## ◆ trim_non_existing_components()

void ojph::local::param_nlt::trim_non_existing_components | ( | ui32 | num_comps | ) |
| private

Definition at line 2073 of file ojph_params.cpp.

References Cnlt, enabled, next, OJPH_INFO, and param_nlt().

Referenced by check_validity().

## ◆ write()

bool ojph::local::param_nlt::write | ( | outfile_base * | file | ) | const

Definition at line 1972 of file ojph_params.cpp.

References BDnlt, Cnlt, enabled, is_any_enabled(), Lnlt, next, ojph::local::NLT, param_nlt(), ojph::local::swap_byte(), Tnlt, and ojph::outfile_base::write().

## Member Data Documentation

## ◆ avail

param_nlt* ojph::local::param_nlt::avail
| private

Definition at line 869 of file ojph_params_local.h.

Referenced by add_object(), destroy(), param_nlt(), and restart().

## ◆ BDnlt

ui8 ojph::local::param_nlt::BDnlt
| private

Definition at line 858 of file ojph_params_local.h.

Referenced by check_validity(), get_nonlinear_transform(), init(), read(), and write().

## ◆ Cnlt

ui16 ojph::local::param_nlt::Cnlt
| private

Definition at line 857 of file ojph_params_local.h.

Referenced by add_object(), get_nlt_object(), get_nonlinear_transform(), init(), read(), trim_non_existing_components(), and write().

## ◆ enabled

bool ojph::local::param_nlt::enabled
| private

Definition at line 860 of file ojph_params_local.h.

Referenced by check_validity(), get_nonlinear_transform(), init(), is_any_enabled(), read(), set_nonlinear_transform(), trim_non_existing_components(), and write().

## ◆ Lnlt

ui16 ojph::local::param_nlt::Lnlt
| private

Definition at line 856 of file ojph_params_local.h.

Referenced by init(), and write().

## ◆ next

param_nlt* ojph::local::param_nlt::next
| private

Definition at line 861 of file ojph_params_local.h.

Referenced by add_object(), destroy(), get_nlt_object(), init(), is_any_enabled(), restart(), trim_non_existing_components(), and write().

## ◆ Tnlt

ui8 ojph::local::param_nlt::Tnlt
| private

Definition at line 859 of file ojph_params_local.h.

Referenced by check_validity(), get_nonlinear_transform(), init(), read(), set_nonlinear_transform(), and write().

The documentation for this struct was generated from the following files:

- /build/openjph/src/OpenJPH/src/core/codestream/ojph_params_local.h
- /build/openjph/src/OpenJPH/src/core/codestream/ojph_params.cpp